"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var reselect_1 = require("reselect");
var Immutable = __importStar(require("immutable"));
/*
  Use to create a complex list where you need more information about
  the item. For instance, if you DO need to fetch more data or to
  manipulate it
*/
var createDataReducer = function (_a) {
    var key = _a.key;
    var getItems = function (state) { return (state.getIn(["entities", key])); }, getItem = (0, reselect_1.createSelector)(getItems, function (_state, id) { return id; }, function (data, id) { return data.get(id) || Immutable.Map(); }), getItemsList = (0, reselect_1.createSelector)(getItems, function (data) { return data.map(function (current) { return current.get("Data"); }).toList(); }), getItemData = (0, reselect_1.createSelector)(getItems, function (_state, id) { return id; }, function (data, id) {
        if (typeof data === "undefined") {
            return Immutable.Map();
        }
        return data.getIn([id, "Data"]);
    }), getItemHasError = (0, reselect_1.createSelector)(getItem, function (data) {
        if (typeof data === "undefined") {
            return false;
        }
        return data.get("error") === true;
    }), getIsFetchingItemInfo = (0, reselect_1.createSelector)(getItem, function (data) {
        if (typeof data === "undefined") {
            return false;
        }
        return data.get("fetching");
    }), getItemIsFetched = (0, reselect_1.createSelector)(getItem, function (data) {
        if (typeof data === "undefined") {
            return false;
        }
        return data.get("fetched");
    }), getShouldFetchItemInfo = (0, reselect_1.createSelector)(getIsFetchingItemInfo, getItemIsFetched, getItemHasError, function (isFetching, isFetched, hasError) { return (!isFetched && !isFetching && !hasError); });
    return {
        getItems: getItems,
        getItem: getItem,
        getItemsList: getItemsList,
        getItemData: getItemData,
        getItemHasError: getItemHasError,
        getIsFetchingItemInfo: getIsFetchingItemInfo,
        getItemIsFetched: getItemIsFetched,
        getShouldFetchItemInfo: getShouldFetchItemInfo,
    };
};
exports.default = createDataReducer;
//# sourceMappingURL=createDataReducer.js.map