"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
/* eslint-disable no-console, max-lines-per-function */
var actionTypes_1 = require("./actionTypes");
var actions_1 = __importDefault(require("./actions"));
var agent_1 = require("./agent");
var receivePage = actions_1.default.receivePage, paginatorMiddleware = function (_a) {
    var dispatch = _a.dispatch;
    return function (next) { return function (action) {
        if (action.type === actionTypes_1.REQUEST_PAGE) {
            var _a = action.meta, endpoint_1 = _a.endpoint, endpointCb_1 = _a.endpointCb, manageEntity_1 = _a.manageEntity, resultsKey_1 = _a.resultsKey, totalKey_1 = _a.totalKey, pageArgName_1 = _a.pageArgName, idKey_1 = _a.idKey, _b = action.payload, page_1 = _b.page, token_1 = _b.token;
            dispatch(function (dispatch2) {
                var markAsError = function () {
                    dispatch2(receivePage({
                        endpoint: endpoint_1,
                        endpointCb: endpointCb_1,
                        manageEntity: manageEntity_1,
                        pageArgName: pageArgName_1,
                        idKey: idKey_1,
                        page: page_1,
                        error: true,
                        token: token_1,
                        items: [],
                        total: 0,
                    }));
                }, rawPath = typeof endpointCb_1 === "function" ? endpointCb_1(token_1) : endpoint_1, path = rawPath === null ? "" : rawPath;
                try {
                    (0, agent_1.fetchPage)({
                        endpoint: path,
                        pageArgName: pageArgName_1,
                        page: page_1,
                        token: token_1,
                    }).then(function (res) {
                        var response = res.response;
                        var results = [], total = 0;
                        if (typeof resultsKey_1 === "undefined") {
                            results = response;
                        }
                        else {
                            results = response[resultsKey_1];
                            total = response[totalKey_1];
                        }
                        dispatch2(receivePage({
                            endpoint: endpoint_1,
                            endpointCb: endpointCb_1,
                            manageEntity: manageEntity_1,
                            pageArgName: pageArgName_1,
                            idKey: idKey_1,
                            page: page_1,
                            error: false,
                            token: token_1,
                            items: results,
                            total: total,
                        }));
                    }).
                        catch(function () {
                        markAsError();
                    });
                }
                catch (err) {
                    markAsError();
                }
            });
        }
        return next(action);
    }; };
};
exports.default = paginatorMiddleware;
//# sourceMappingURL=paginatorMiddleware.js.map