"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var Immutable = __importStar(require("immutable"));
var reselect_1 = require("reselect");
var pagesSelector = function (state) { return state; }, pageSelector = (0, reselect_1.createSelector)(pagesSelector, function (_state, token) { return token; }, function (pages, token) { return pages.get(token); }), getAllResults = (0, reselect_1.createSelector)(pageSelector, function (_state, _token, items) { return items; }, function (page, items) {
    if (typeof page === "undefined") {
        return Immutable.List();
    }
    return page.get("ids").map(function (id) { return items.get(String(id)); });
}), getResultsUpToPage = (0, reselect_1.createSelector)(pageSelector, function (_state, _token, items) { return items; }, function (_state, _token, _items, target) { return target; }, function (_state, _token, _items, _target, perPage) { return (perPage); }, function (page, items, target, perPage) {
    if (typeof page === "undefined") {
        return Immutable.List();
    }
    var ids = page.get("ids").slice(0, perPage * target);
    return ids.map(function (id) { return items.get(String(id)); });
}), getCurrentTotalResultsCount = (0, reselect_1.createSelector)(pageSelector, function (page) {
    if (typeof page === "undefined") {
        return 0;
    }
    return page.get("total");
}), isPageFetching = (0, reselect_1.createSelector)(pageSelector, function (_state, _token, target) { return target; }, function (page, target) {
    if (typeof page === "undefined") {
        return false;
    }
    return page.get("fetching") && target === page.get("page");
}), isPageFetched = (0, reselect_1.createSelector)(pageSelector, function (_state, _token, target) { return target; }, function (page, target) {
    if (typeof page === "undefined") {
        return false;
    }
    return page.get("fetched") && target <= page.get("page");
}), hasPageProblems = (0, reselect_1.createSelector)(pageSelector, function (page) {
    if (typeof page === "undefined") {
        return false;
    }
    return page.get("error");
}), getCurrentView = (0, reselect_1.createSelector)(pageSelector, function (page) {
    if (typeof page === "undefined") {
        return 1;
    }
    return page.get("view");
}), 
// these selectors are used for the entire app
getPaginatorPaginations = function (state, name) { return state.getIn(["paginations", name]); }, getPaginatorEntities = function (state, name) { return state.getIn(["entities", name]); }, getPaginators = (0, reselect_1.createSelector)(getPaginatorPaginations, getPaginatorEntities, function (list, entities) { return ({
    list: list,
    entities: entities,
}); });
exports.default = {
    getAllResults: getAllResults,
    getCurrentTotalResultsCount: getCurrentTotalResultsCount,
    getResultsUpToPage: getResultsUpToPage,
    isPageFetching: isPageFetching,
    isPageFetched: isPageFetched,
    hasPageProblems: hasPageProblems,
    getCurrentView: getCurrentView,
    // for state
    getPaginatorPaginations: getPaginatorPaginations,
    getPaginatorEntities: getPaginatorEntities,
    getPaginators: getPaginators,
};
//# sourceMappingURL=selectors.js.map